#! /bin/bash
rm main.sav ../bin/tclp
sicstus -l compile || (echo 'compile failed !';exit 1) || exit 1
echo compile finished
mkdir -p ../bin
if [ ! -L ../bin/lib ] && [ ! -d ../bin/lib ]
then ln -s ../lib ../bin/lib
fi

sicstus_version=`sicstus --goal halt. 2>&1 | sed -n -e 's/^SICStus \([0-9.]*\).*$/\1/p'`
sicstus_major=`echo $sicstus_version | sed -n 's/\([0-9]*\).*/\1/p'`
sicstus_minor=`echo $sicstus_version | sed -n 's/[0-9]*\.\([0-9]*\).*/\1/p'`

if [ $sicstus_major -gt 3 ] 
then
    compile_opt=3.10
elif [ $sicstus_major = 3 ] && [ $sicstus_minor -ge 10 ]
then 
    compile_opt=3.10
elif [ $sicstus_major = 3 ] && [ $sicstus_minor -ge 9 ]
then
    compile_opt=3.9
elif [ $sicstus_major = 3 ] && [ $sicstus_minor -ge 8 ]
then
    compile_opt=3.8
fi

echo "SICStus version is $sicstus_version"
case "$compile_opt" in
    3.8 )
        echo "Using spld options for SICStus 3.8 ..."
        spld -o tclp lib/sicstus-3.8.5/bin/main.sav \
            --static \
            --resources=chr,charsio,system,random \
            --moveable && \
        date
    ;;
    3.9 )
        echo "Using spld options for SICStus 3.9 ..."
        spld --static \
            --main=restore \
            --resources=chr,charsio,system,random,main.sav=./main.sav \
            --output=../bin/tclp && \
        date
    ;;
    3.10 )
        echo "Using spld options for SICStus 3.10 ..."
        spld --static \
            --main=restore \
            --resources-from-sav \
            --resources=main.sav=./main.sav \
            --output=../bin/tclp && \
        date
    ;;
    * )
        echo "Don't know how to compile with SICStus $sicstus_version ..."
        exit 1
    ;;
esac
